--- main/asterisk.c	2007/12/19 00:22:06	1.1
+++ main/asterisk.c	2007/12/19 00:28:32
@@ -2329,6 +2329,7 @@
 	printf("   -T              Display the time in [Mmm dd hh:mm:ss] format for each line of output to the CLI.\n");
 	printf("   -v              Increase verbosity (multiple v's = more verbose)\n");
 	printf("   -x <cmd>        Execute command <cmd> (only valid with -r)\n");
+	printf("   -s <socket>     Connect to Asterisk via socket <socket> (only valid with -r)\n");
 	printf("\n");
 	return 0;
 }
@@ -2526,6 +2527,7 @@
 	int is_child_of_nonroot = 0;
 	char *buf;
 	char *runuser = NULL, *rungroup = NULL;
+	char *remotesock = NULL;
 
 	/* Remember original args for restart */
 	if (argc > sizeof(_argv) / sizeof(_argv[0]) - 1) {
@@ -2557,7 +2559,7 @@
 	if (getenv("HOME")) 
 		snprintf(filename, sizeof(filename), "%s/.asterisk_history", getenv("HOME"));
 	/* Check for options */
-	while ((c = getopt(argc, argv, "mtThfFdvVqprRgciInx:U:G:C:L:M:")) != -1) {
+	while ((c = getopt(argc, argv, "mtThfFdvVqprRgciInx:U:G:C:L:M:s:")) != -1) {
 		switch (c) {
 #if HAVE_WORKING_FORK
 		case 'F':
@@ -2639,6 +2641,9 @@
 		case 'G':
 			rungroup = optarg;
 			break;
+		case 's':
+			remotesock = optarg;
+			break;
 		case '?':
 			exit(1);
 		}
@@ -2670,6 +2675,9 @@
 	if (ast_opt_console && !option_verbose) 
 		ast_verbose("[ Reading Master Configuration ]\n");
 	ast_readconfig();
+
+	if (ast_opt_remote && remotesock != NULL)
+		ast_copy_string(ast_config_AST_SOCKET, remotesock, sizeof(ast_config_AST_SOCKET));
 
 	if (ast_opt_dump_core) {
 		struct rlimit l;
